#include "../botolib.h"

DWORD palette[256];
int   table[256][256];


void Init(void)
{
	Cls();
	for (int i=0;i<64;i++)
	{
		Color(0,0,i*4);
		Line(i,0,i,200);
	}
	for (i=0;i<128;i++)
	{
		Color(0,(i/2)*4,63*4);
		Line(i+64,0,i+64,200);
	}
	for (i=0;i<64;i++)
	{
		Color(i*4,63*4,63*4);
		Line(i+192,0,i+192,200);
	}
	for (int x=0;x<256;x++)
		palette[x] = GetColor(x,0)|0xFF000000;

	for (int y=0;y<256;y++)
	{
		for (x=0;x<256;x++)
		{
			if (x==0 && y==0)

				table[y][x]=255;
			else 
				table[y][x]=(9000.0 / (sqrtf(x*x + y*y) * 7.0));
		}
	}
}

void BotoMain()
{
    Graphics(640,480,32,1);

	AppTitle("Blobs");

	HidePointer();

	Init();

	float alfa = 0;
	float hw = (float)256 / 2.0f;
	float hh = (float)256 / 2.0f;

	DWORD image = CreateImage(256,256);
	ResizeImage(image,GraphicsWidth(),GraphicsHeight());

	while (PumpMessages())
	{
		if (KeyHit(VK_ESCAPE)) break;
		if (KeyHit(VK_F12)) SaveBuffer(BackBuffer(),"shot.bmp");

		float x1 = 60.0f * Cos(alfa)    + 30.0f * Sin(-alfa)  + hw;

		float y1 = 30.0f * Cos(-alfa*2) + 60.0f * Sin(alfa)   + hh;
		float x2 = 30.0f * Cos(alfa)    + 60.0f * Sin(alfa*2) + hw;
		float y2 = 60.0f * Cos(alfa)    + 30.0f * Sin(alfa)   + hh;
		float x3 = 45.0f * Cos(-alfa)   + 45.0f * Sin(alfa)   + hw;
		float y3 = 45.0f * Cos(alfa*2)  + 45.0f * Sin(-alfa)  + hh;
		float x4 = 75.0f * Cos(alfa)    + 15.0f * Sin(alfa*2) + hw;
		float y4 = 15.0f * Cos(-alfa)   + 75.0f * Sin(alfa*2) + hh;
		float x5 = 35.0f * Cos(alfa)    + 10.0f * Sin(alfa)   + hw;
		float y5 = 10.0f * Cos(alfa*2)  + 35.0f * Sin(-alfa)  + hh;

		float x6 = 40.0f * Cos(-alfa)   + 30.0f * Sin(alfa*2) + hw;
		float y6 = 40.0f * Cos(alfa)    + 10.0f * Sin(alfa)   + hh;

		alfa += 3;

		Cls();

		LockBuffer(ImageBuffer(image));
		for (int y=0;y<256;y++)
		{
			for (int x=0;x<256;x++)
			{
				int pixel=table[(int)Abs(y1-y)][(int)Abs(x1-x)]+
					      table[(int)Abs(y2-y)][(int)Abs(x2-x)]+
					      table[(int)Abs(y3-y)][(int)Abs(x3-x)]+
					      table[(int)Abs(y4-y)][(int)Abs(x4-x)]+
					      table[(int)Abs(y5-y)][(int)Abs(x5-x)]+
					      table[(int)Abs(y6-y)][(int)Abs(x6-x)];

				if (pixel<0) pixel=0;
				if (pixel>255) pixel=255;
				WritePixelFast(x,y,palette[pixel],ImageBuffer(image));
			}
		}
		UnlockBuffer(ImageBuffer(image));

		DrawImage(image,0,0);
		Flip();
	}
} 

